/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2006 by Witz Corporation, JAPAN
 * 
 *  上記著作権者は，以下の (1)〜(4) の条件か，Free Software Foundation 
 *  によって公表されている GNU General Public License の Version 2 に記
 *  述されている条件を満たす場合に限り，本ソフトウェア（本ソフトウェア
 *  を改変したものを含む．以下同じ）を使用・複製・改変・再配布（以下，
 *  利用と呼ぶ）することを無償で許諾する．
 *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
 *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
 *      スコード中に含まれていること．
 *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
 *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
 *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
 *      の無保証規定を掲載すること．
 *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
 *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
 *      と．
 *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
 *        作権表示，この利用条件および下記の無保証規定を掲載すること．
 *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
 *        報告すること．
 *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
 *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
 * 
 *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
 *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，その適用可能性も
 *  含めて，いかなる保証も行わない．また，本ソフトウェアの利用により直
 *  接的または間接的に生じたいかなる損害に関しても，その責任を負わない．
 * 
 *  @(#) $Id: tool_defs.h,v 1.1 2006/04/10 08:19:25 honda Exp $
 */

/*
 *	開発環境に依存する定義
 *
 *  このインクルードファイルは，t_stddef.h と itron.h の先頭でインクルー
 *  ドされる．他のファイルからは直接インクルードすることはない．他のイ
 *  ンクルードファイルに先立って処理されるため，他のインクルードファイ
 *  ルに依存してはならない．
 */

#ifndef _TOOL_DEFS_H_
#define _TOOL_DEFS_H_

/*
 *  コンパイラ依存のデータ型の定義
 */
#define	_int8_		char		/* 8ビットの整数型 */
#define	_int16_		int		/* 16ビットの整数型 */
#define	_int32_		long		/* 32ビットの整数型 */

/*
 *  コンパイラの拡張機能のためのマクロ定義
 */

#include "api.h"

/*
 *  TOSHIBA IDEでは#pragma inline記述にてインライン関数を定義する
 *  このためカーネル内部にのみ以下の処理を適用する．
 *  カーネル共通部のInlineおよびinlineの定義は全て無効とし，既知の
 *  インライン関数に対する#pragma inline定義をkernel_inline_defs.h
 *  に記載し，そのファイルを本箇所にてインクルードする．
 */

#ifndef _MACRO_ONLY
#include "kernel_inline_defs.h"
#endif	/* _MACRO_ONLY	*/

#define	Inline


/*
 *  TOSHIBA IDEでは２種類のインラインアセンブラ命令がある
 *  __asm	: レジスタ退避有り(低速だがレジスタ破壊がない)
 *  __ASM	: レジスタ退避無し(高速だがレジスタ破壊に注意)
 *  カーネル内部で使用することを前提に__AMSを採用する
 */
#ifndef __cplusplus			/* C++ には asm がある */
#define	asm		__ASM
#endif /* __cplusplus */

#define	Asm		__ASM

#endif /* _TOOL_DEFS_H_ */
